//////////////////////////////////////////////////////////////////////////
//Aus der klassischen Mandelbrotmenge ein c-Wert für gefüllte Julia-Menge wählen.
//Mit Rechtsklick Orbits und eventuelle periodische Attraktoren einzeichnen
//Mit Taste f Fixpunkte eintragen.
////////////////////////////////////////////////////////////////////////

ArrayList<Threads> threads;
Complex zNeu,zAlt,C,z0,z1,z,zA,zB;
double xU = -1.8; 
double yU = -1.8; 
double xO = 1.8;
double yO = 1.8;
double zoomFaktor=1;
double wh = xO-xU;
double D;
double laenge,l0,l1;
double a,b;
float A,B;
int maxiterations = 400;
int orbitZeichnenAb = 1000;
int punktGroesse;
int anzahlOrbitPunkte = 2000;
double massFuerUnendlich = 1000;
int nummerThread;
int anzahlThreads = Runtime.getRuntime().availableProcessors(); 
double x0,y0;
boolean Julia;
boolean farbig = false;
boolean orbitZeichnen = false;
boolean FPzeichnen = false;
boolean cWerteEintragen= false; //spezielle c-Werte in Mandelbrot-Menge markieren
color farbe;

void setup() {
  background(255);
  noLoop();
  colorMode(RGB);
  threads = new  ArrayList<Threads>(); 
  size(800, 800);
  x0 = -0.7269;  y0 = 0.1889;
  C = new Complex(x0,y0);
  zAlt = new Complex(0,0); 
  zNeu = new Complex(0,0);
  
  Julia = false;
  nummerThread =0;
  println("Anzahl Threads: "+anzahlThreads);
  starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread, x0, y0, Julia);
  
}

/////////////////////////////////////////////////////////////////

void starteThreads(double px, double py, int pmaxiterations, double pUnendlich, double pwh, int nummer, double X0, double Y0, boolean julia ){
  x0 = X0; y0 = Y0;
  xU = px; yU = py;
  nummerThread = nummer;
  maxiterations = pmaxiterations;
  massFuerUnendlich = pUnendlich;
  wh = pwh;
  double  y= yO-wh/anzahlThreads;
  while(nummerThread <anzahlThreads){
        Threads t = new Threads(xU,y,maxiterations,massFuerUnendlich,wh/anzahlThreads, nummerThread,x0,y0,Julia);
        //println(xU,y,maxiterations,massFuerUnendlich,wh/anzahlThreads, nummerThread);
        threads.add(t);
        t.start(); 
        nummerThread++;
        y=y-wh/anzahlThreads;
        delay(50);//zur Verringerung der Pixelfehler
    
  }
  
}
//////////////////////////////////////////////////////////////

void draw() {

  for(Threads t: threads){
      while (t.running){       
            try{
            Thread.sleep(10);  
            }catch (Exception e) {  }  ;                
       }
  }
  
  for (int i=0; i<threads.size(); i++){
    image(threads.get(i).pg,0,i*height/anzahlThreads);
   
  }  
  
  if(orbitZeichnen == true){
      int m =juliaIteration(z0,anzahlOrbitPunkte);
      println(m);//Kontrolle
      orbitZeichnen = false;
      farbig = false;
  }
  if(FPzeichnen==true){
      println("Fixpunkte eintragen");
      fixPunkteBestimmen();
      PunkteEintragen(z0,z1);
      FPzeichnen = false;
  }  
  if(cWerteEintragen && !Julia){//spezielle c-Werte einzeichnen
    zA = new Complex(-0.7356528043746948D,0.13968722522258759D); 
    zB = new Complex(-0.39054,-0.58679);
    PunkteEintragen(zA,zB);
    zA = new Complex(-0.481762,-0.531657); 
    zB = new Complex(0.25,-0.5642857551574707D);
    PunkteEintragen(zA,zB);
    zA = new Complex(0.32,0.043); 
    zB = new Complex(-0.7464286088943481D,0.0035715103149414062D);
    PunkteEintragen(zA,zB);
    zA = new Complex(-1.48,0); 
    zB = new Complex( -0.75,0);
    PunkteEintragen(zA,zB);
    zA = new Complex(0,0); 
    zB = new Complex(0.2696255147457123D,0.005362700670957565D);
    PunkteEintragen(zA,zB);
    zA = new Complex(0.06834238767623901D,0.6154803037643433D); 
    zB = new Complex(-0.10933917760848999D,0.894686222076416D);
    PunkteEintragen(zA,zB);
    zA = new Complex(0.06831155717372894D,0.6153849959373474D); 
    zB = new Complex(-0.5444999933242798D,-0.11249995231628418D);
    PunkteEintragen(zA,zB);
  }
     
}
//////////////////////////////////////////////////////////////////////
int juliaIteration(Complex Z, int M) {
  int maxIt = M;
  int n = 0;
  a = Z.getRealPart();
  b = Z.getImaginaryPart(); 
  zAlt = new Complex(a,b);
  if(farbig) {
     colorMode(HSB,255,255,255);
     farbe = color(random(0,255),255,255);
     stroke(farbe);
     
   }else{
      stroke(0,255,0);
      colorMode(RGB, 255,255,255);
    }  
  strokeWeight(6);
 
  A = map((float)a,(float)xU,(float)xO,0,width);
  B = map((float)b,(float)yU,(float)yO,height,0); 
  point(A,B);
  

  while (n < maxIt) {
    zNeu = zAlt.multiply(zAlt);
    zNeu = zNeu.addC(C);
    laenge = zNeu.getLength();
    if (laenge > massFuerUnendlich) {
      break;  // Bail
    }
    a = zNeu.getRealPart();
    b = zNeu.getImaginaryPart();
    if(orbitZeichnen && n > orbitZeichnenAb){         
      A = map((float)a,(float)xU,(float)xO,0,width);
      B = map((float)b,(float)yU,(float)yO,height,0);
      if(farbig) stroke(farbe);
        else stroke(255,0,0);
      strokeWeight(punktGroesse);
      point(A,B); 
    }
    zAlt = new Complex(a,b);
    n++; 
  }
  return n;
 }
 ///////////////////////////////////////////////////////////////////////
void fixPunkteBestimmen(){
 
  z0= new Complex(0,0);
  z1= new Complex(0,0);
  
  z0 = C.multiply(-4D); 
  z0 = z0.addC(1D); 
  z0 = z0.sqrtC(); 
  z1=z0;
  z0 = z0.multiply(-0.5D);
  z1 = z1.multiply(0.5D);
  
  z0 = z0.addC(0.5D); l0 = z0.getLength(); 
  z1 = z1.addC(0.5D); l1 = z1.getLength();
  if(l0 < l1){ //erster Wert soll auf Julia-Menge liegen
    z  = z1; 
    z1 = z0;
    z0 = z;
  }  
}
///////////////////////////////////////////////////////////////
void PunkteEintragen(Complex Z1, Complex Z2){
  zAlt = Z1; 
  colorMode(RGB);
  strokeWeight(10);
  if(cWerteEintragen && !Julia) stroke(255,255,0);
    else stroke(255,0,0);
  //Fixpunkt (abstoßend) auf Julia-Menge oder spezielle c-Werte
  a = zAlt.getRealPart();
  b = zAlt.getImaginaryPart();
  A = map((float)a,(float)xU,(float)xO,0,width);
  B = map((float)b,(float)yU,(float)yO,height,0); 
  point(A,B); 
  //Fixpunkt (anziehend) in Gefangenen-Menge oder spezielle c-Werte
  if(cWerteEintragen && !Julia) stroke(255,255,0);
     else stroke(0,0,255);
  a = Z2.getRealPart();
  b = Z2.getImaginaryPart();
  A = map((float)a,(float)xU,(float)xO,0,width);
  B = map((float)b,(float)yU,(float)yO,height,0); 
  point(A,B);   
}

/////////////////////////////////////////////////////////////////
void mousePressed() { 
     nummerThread =0;
     threads = new  ArrayList<Threads>(); 
     double xUNeu, xONeu, yUNeu, yONeu;//Temp. Speicher
            
     if (mouseButton == LEFT){
        if(keyPressed == true && keyCode == SHIFT){//Vergrößern
          xUNeu = map(mouseX,0,width,(float)xU,(float)xO)-(xO-xU)/10;
          xONeu = map(mouseX,0,width,(float)xU,(float)xO)+(xO-xU)/10; 
          xU = xUNeu; xO = xONeu; 
          yUNeu = map(mouseY,height,0,(float)yU,(float)yO)-(yO-yU)/10;
          yONeu = map(mouseY,height,0,(float)yU,(float)yO)+(yO-yU)/10; 
          yU =yUNeu; yO = yONeu; 
          wh = wh/5;
          zoomFaktor =zoomFaktor*5;
          println("Zoomfaktor: "+zoomFaktor);
          starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread, x0, y0, Julia);  
          redraw();
        }else if (keyPressed == false){
          if(!Julia){//Wenn Julia schon gezeichnet kann kein c-Wert entnommen werden
            Julia = true;
            x0 = map(mouseX,0,width,(float)xU,(float)xO);
            y0 = map(mouseY,height,0,(float)yU,(float)yO);
            C = new Complex(x0,y0);//c-Wert speichern
            xU = -1.8; 
            yU = -1.8; 
            xO = 1.8;
            yO = 1.8;
            zoomFaktor=1;
            wh = xO-xU;
            println("Neuer Wert für die Konstante c:  x0= "+x0+"; y0 ="+ y0 +";");
            starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread,x0,y0,Julia);
            redraw();
          }
        }
     }
   if (mouseButton == RIGHT){   
     if (keyPressed == true && keyCode == SHIFT){//Orbit von Beginn an einzeichnen
          orbitZeichnen = true;
          farbig = true;//bei jedem Klick neue Farbe
          orbitZeichnenAb = 1;
          anzahlOrbitPunkte = 800;
          punktGroesse =2;
          orbitZeichnen = true;
          float xH = map(mouseX,0,width,(float)xU,(float)xO); 
          float yH = map(mouseY,0,height, (float)yO,(float)yU);
          z0 = new Complex(xH,yH);
          println("Orbit Punkte zeichnen von Beginn");
          redraw();
         
     }else if (keyPressed == false && Julia){ //Orbit ab Element 500 einzeichnen
          orbitZeichnen = true;
          orbitZeichnenAb = 500;
          anzahlOrbitPunkte = 2000;
          punktGroesse =4;   
          farbig = false;
          orbitZeichnen = true;
          float xH = map(mouseX,0,width,(float)xU,(float)xO); 
          float yH = map(mouseY,0,height, (float)yO,(float)yU);
          z0 = new Complex(xH,yH);
          println("Orbit Punkte zeichnen ab n = 500");
          redraw();
     }
 }     
}  
/////////////////////////////////////////////////////////////////
void keyPressed() {
  //skiziert die Mandelbrotmenge
  if (key == 'm'){
     FPzeichnen = false;
     cWerteEintragen= false;
     nummerThread =0;
     background(0);
     Julia = false;
     println("Mandelbrot");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread, x0, y0, Julia);
  }
  //Fixpunkte eintragen
  if (key == 'f'){
      println("Fixpunkte zeichnen");
      FPzeichnen=true;
      redraw();
  } 
  if (key == 'c'){
      println("Spezielle c-Werte eintragen");
      cWerteEintragen=true;
      redraw();
  }   

  //erhöht die Anzahl der Iterationen
  if (key == '+'){
     nummerThread =0;
     background(0);
     maxiterations *= 1.2; println("Iterationsgrenze: "+maxiterations);
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread, x0, y0, Julia);
  }
  //verringert die Anzahl der Iterationen
  if (key == '-') {
      nummerThread =0;
      background(0);
      maxiterations /= 1.2;println("Iterationsgrenze: "+maxiterations);
      threads = new  ArrayList<Threads>(); 
      starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread, x0, y0, Julia);  
  }
   //zoomen mit Faktor 2
   if (key == 'z'){
     double xUNeu, xONeu, yUNeu, yONeu;//Temp. Speicher
     nummerThread =0;
     background(0);
     xUNeu = xU+0.25*(xO-xU);yUNeu = yU+0.25*(yO-yU);
     xONeu = xO-0.25*(xO-xU);yONeu = yO-0.25*(yO-yU);
     xU = xUNeu;xO = xONeu; 
     yU =yUNeu; yO = yONeu; 
     wh=wh/2;
     zoomFaktor =zoomFaktor*2;
     println("Zoomfaktor: "+zoomFaktor);
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread, x0, y0, Julia);
  }
  //Verschiebungen nach links,rechts,unten,oben - wenn die Zentrierung plus Vergrößerung mit
  //Mausklick links nicht genau genug ist.
  if (key == 'l'){
     nummerThread =0;
     background(0);
     xO = xO + wh/10;
     xU = xU + wh/10;
     println("Verschiebung nach Links");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread, x0, y0, Julia);
  }
  if (key == 'r'){
     nummerThread =0;
     background(0);
     xO = xO - wh/10;
     xU = xU - wh/10;
     println("Verschiebung nach Rechts");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread, x0, y0, Julia);
  }
   if (key == 'u'){
     nummerThread =0;
     background(0);
     yO = yO + wh/10;
     yU = yU + wh/10;
     println("Verschiebung nach unten");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread, x0, y0, Julia);
  }
  if (key == 'o'){
     nummerThread =0;
     background(0);
     yO = yO - wh/10;
     yU = yU - wh/10;
     println("Verschiebung nach oben");
     threads = new  ArrayList<Threads>(); 
     starteThreads(xU, yU, maxiterations, massFuerUnendlich, wh, nummerThread, x0, y0, Julia);
  }
  if (key == 's') save("mandelbrot.png");
  redraw();
}
/////////////////////////////////////////////////////////////////
